/*
 * Written by Professor Bill Tomlinson for Winter 2004 Biomorphic Computing class at UCI.
 * wmt@uci.edu
 */
public class Vec2 {
	double x;
	double y;
	public Vec2() {
		this.x = 0;
		this.y = 0;
	}
	public Vec2(double x, double y) {
		this.x = x;
		this.y = y;
	}
	public double getX() {
		return x;
	}
	public double getY() {
		return y;
	}
	public void setX(double x) {
		this.x = x;
	}
	public void setY(double y) {
		this.y = y;
	}
	public void setValue(double x, double y) {
		this.x = x;
		this.y = y;
	}
	public void setValue(Vec2 v) {
		this.x = v.getX();
		this.y = v.getY();
	}
	public Vec2 add(Vec2 p) {
		return new Vec2(x + p.getX(), y + p.getY());
	}
	public Vec2 sub(Vec2 p) {
		return new Vec2(x - p.getX(), y - p.getY());
	}
	public Vec2 scale(double d) {
		return new Vec2(x * d, y * d);
	}
	public Vec2 normalize() {
		double mag = this.mag();
		if (mag == 0)
			return new Vec2(-1, 0);
		return new Vec2(x / mag, y / mag);
	}
	public double mag() {
		return Math.sqrt(x * x + y * y);
	}
	public String toString() {
		return "(" + x + ", " + y + ")";
	}
	public double dot(Vec2 b) {
		Vec2 aNormalized = this.normalize();
		Vec2 bNormalized = b.normalize();
		return (
			aNormalized.getX() * bNormalized.getX()
				+ aNormalized.getY() * bNormalized.getY());
	}
	public boolean isToTheLeftOf(Vec2 b) {
		double z = this.getX() * b.getY() - this.getY() * b.getX();
		if (z > 0)
			return true;
		return false;
	}
}
